.586
.model flat,stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\shell32.inc
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\shell32.lib

WinMain PROTO   :DWORD,:DWORD,:DWORD,:DWORD
FillControls    PROTO

.data

hInstance   dd      ?
hMainWindow dd      ?
MainWindowClass db  'MainWindowClass',0
MainWindowName  db  'Elmos listview file deletion',0

hList1      dd      ?
ListViewClass   db      'SysListView32',0
lvc     LV_COLUMN   <>
lvi     LV_ITEM     <>

hFind   dd      ?
w32fd   WIN32_FIND_DATA     <>
szPathSpec  db  'd:\masm32\*',0
rect    RECT   <>
FileNameString  db      'FileName',0
CurrentDirectory    db  'd:\masm32',0
FileNameBuffer  dd  256 dup(0)
Success     db      'File Deleted Successfully',0
Deletion    db      'Deletion',0

wc  WNDCLASSEX  <sizeof wc,CS_HREDRAW+CS_VREDRAW,offset WndProc,NULL,NULL,NULL,NULL,NULL,\
                COLOR_WINDOW,NULL,offset MainWindowClass,NULL>
.code
    start:
        invoke  GetModuleHandle,NULL
        mov hInstance,eax
        invoke  WinMain,hInstance,NULL,NULL,SW_SHOWNORMAL
        invoke  ExitProcess,eax
WinMain PROC    hInst:DWORD,hPInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

    local   msg:MSG

    push    hInst
    pop     wc.hInstance
    invoke  LoadIcon,NULL,IDI_APPLICATION
    mov     wc.hIcon,eax
    mov     wc.hIconSm,eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wc.hCursor,eax
    invoke  RegisterClassEx,addr wc
    invoke  CreateWindowEx,NULL,addr MainWindowClass,addr MainWindowName,WS_TILEDWINDOW,\
                0,0,600,350,NULL,NULL,hInst,NULL
    mov hMainWindow,eax
    invoke  ShowWindow,eax,CmdShow
    invoke  UpdateWindow,hMainWindow

msg_loop:
    invoke  GetMessage,addr msg,NULL,0,0
    or      eax,eax
    jz      end_msg_loop
    invoke  TranslateMessage,addr msg
    invoke  DispatchMessage,addr msg
    jmp     msg_loop
end_msg_loop:
    mov     eax,msg.wParam
    ret

WinMain endp

WndProc PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    local   fo:SHFILEOPSTRUCT
    .if uMsg==WM_DESTROY
        invoke  PostQuitMessage,NULL
    .elseif uMsg==WM_CREATE
        mov edi,lParam
        .if [edi.CREATESTRUCT].hWndParent==NULL
            invoke  GetClientRect,hWnd,addr rect
            invoke  CreateWindowEx,WS_EX_STATICEDGE,addr ListViewClass,NULL,WS_VISIBLE+WS_CHILD\
                        +LVS_REPORT,0,0,rect.right,rect.bottom,hWnd,NULL,hInstance,NULL
            mov hList1,eax
            mov lvc.imask,LVCF_TEXT+LVCF_WIDTH
            push    rect.right
            pop lvc.lx
            mov lvc.pszText,offset FileNameString
            invoke  SendMessage,hList1,LVM_INSERTCOLUMN,1,addr lvc
            invoke  FillControls
        .endif       
    .elseif uMsg==WM_NOTIFY
        mov edi,lParam
        .if [edi.NM_LISTVIEW].hdr.code==LVN_ITEMCHANGED
           test [edi.NM_LISTVIEW].uNewState,LVIS_SELECTED
           jz   no_sel
                push    [edi.NM_LISTVIEW].iItem
                pop lvi.iItem
                mov lvi.pszText,offset FileNameBuffer
                invoke  SendMessage,hList1,LVM_GETITEM,NULL,addr lvi
                invoke  SetCurrentDirectory,addr CurrentDirectory
                push    hWnd
                pop     fo.hwnd
                mov     fo.wFunc,FO_DELETE
                push    Offset FileNameBuffer
                pop     fo.pFrom
                invoke  SHFileOperation,addr fo
                .if fo.fAnyOperationsAborted==FALSE
                       invoke  MessageBox,hWnd,addr Success,addr Deletion,MB_OK
                      ; invoke  SendMessage,hList1,LVM_DELETEITEM,[edi.NM_LISTVIEW].iItem,NULL
                .endif 

        .endif        
no_sel:                                                                            
    .else
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    xor eax,eax
    ret

WndProc endp                          

 ; ElmoDelete  PROC
 ;                         
 ; ;STEP1. GET FILE NAME FROM THE LIST VIEW
 ; 					INVOKE SendMessage, hList1, LVM_GETNEXTITEM, -1, LVNI_FOCUSED		;GET ROW ID
 ; 					mov lvi.iItem, eax
 ; 					mov lvi.iSubItem, 0
 ; 					mov lvi.imask, LVIF_TEXT
 ; 					lea eax, szFileName          ;THIS IS CONTAIN file1.txt
 ; 					mov lvi.pszText, eax
 ; 					mov lvi.cchTextMax, 256
 ; 					INVOKE SendMessage, hList1, LVM_GETITEM, 0, addr lvi
 ; 
 ; 
 ; 
 ; 				;STEP2.GET CURRENT FILE PATH
 ; 					invoke SetCurrentDirectory,SADD("C:\")
 ; 					invoke lstrcat,ADDR szPath,addr szFileName         ;IN HERE, szPath WILL CONTAIN C:\file1.txt
 ; 
 ; 				;STEP3.DO DELETE
 ; 					;mov fo.hwnd,NULL
 ; 					;mov fo.wFunc, FO_DELETE
 ; 					;lea eax,szPath
 ; 					;mov fo.pFrom,eax
 ; 					;mov fo.pTo,NULL
 ; 					;mov fo.fFlags,FOF_ALLOWUNDO
 ; 					;invoke SHFileOperation,ADDR fo
 ; 
 ; 					invoke szTrim,addr szFileName
 ; 					invoke DeleteFile,ecx
 ; 					.if eax==1
 ; 						invoke MessageBox,0,SADD("delete ok"),SADD("delete"),0
 ; 					.else
 ; 						invoke MessageBox,0,SADD("delete failed"),SADD("delete"),0
 ; 					.endif
 ; ElmoDelete  endp 
 ; 
FillControls    PROC

    mov lvi.imask,LVIF_TEXT
    mov lvi.pszText,offset w32fd.cFileName
    mov lvi.iSubItem,NULL
    mov lvi.iItem,NULL
    mov lvi.cchTextMax,256
    invoke  FindFirstFile,addr szPathSpec,addr w32fd
    cmp eax,NULL
    je  error_no_more_files
    mov hFind,eax
compares:
    cmp w32fd.cFileName,'.'
    je  next_file
    test    w32fd.dwFileAttributes,FILE_ATTRIBUTE_ARCHIVE
    jnz do_it
next_file:
    invoke  FindNextFile,hFind,addr w32fd
    cmp     eax,NULL
    je      error_no_more_files
    jmp     compares
do_it:
    invoke  Beep,20,1
    invoke  SendMessage,hList1,LVM_INSERTITEM,NULL,addr lvi
    inc lvi.iItem 
    jmp next_file
error_no_more_files:
    invoke  CloseHandle,hFind
    ret

FillControls    endp                

end start